Description

Of course I know that Github is not a SCM!  But it is so widely used that many users of Redmine-powered sites likely to have their

projects on Github...

Saying if the plugin requires SCM to be chosen on project creation and a user hosts its project on Github. Administrators of this

Redmine-powered site may want to allow Github... So I’m thinking about adding a “virtual” SCM type “Github” which will just add

external Github repository to the project.

Associated revisions

Revision 130 - 04 May 2014 21:12 - Andriy Lesyuk

Github SCM, cloning and fetching updates (#1950)

Revision 131 - 05 May 2014 08:31 - Andriy Lesyuk

Added credentials for Github (#1950)

Revision 132 - 06 May 2014 10:48 - Andriy Lesyuk

GithubCreator support (#1950), SCMCreator interface fixes, hooks removal (#1886)

Revision 133 - 07 May 2014 23:42 - Andriy Lesyuk

GithubCreator improvements and fixes (#1950)

Revision 134 - 09 May 2014 23:47 - Andriy Lesyuk

Implemented hook registration (#1950)

Revision 135 - 10 May 2014 21:10 - Andriy Lesyuk

Hook registration and auto-creation fixes (#1950)

History

#1 - 13 Feb 2012 21:45 - Declan Lynch

This is a feature that I would love to see also.

I would imagine that 'GitHub’ would become a choice on the SCM type dropdown and if selected extra fields for the GitHub repository/user/token

would showup. When filled in the scm-creator would then do a 'git clone --mirror [repositoryurl] [localpath/projectid]' which will pull down the repository

from GitHub and setup RedMine to point to the local mirror. You’d have to look at where to store the github user/token. if it is a public github repository

then the user/token is not required.

Using the GitHub_Hook redmine plugin the GitHub user would then be able to setup a post url in GitHub so that when they push a changeset to

GitHub it would call that url to tell RedMine to fetch the latest changes into the mirrored repository.
#2 - 14 Feb 2012 18:25 - Andriy Lesyuk

Actually I was thinking about using Github URL directly... Without mirroring it localy.

#3 - 16 Feb 2012 14:24 - Lloyd Philbrook

That is an interesting approach.  I understand with the new github API you can pull commit messages and even blobs, but how would you handle

showing diffs or viewing source code in that scenario?

#4 - 09 Jun 2012 20:54 - Andriy Lesyuk

I think you understood me wrong...

A virtual Github repo type should be just Git repo. But it should be easier to add Git repo from Github using this virtual SCM.

Right now when I try adding Github URL I get:

fatal: Not a git repository: 'https://github.com/edavis10/redmine.git'

#5 - 09 Jun 2012 22:06 - Andriy Lesyuk

Another related links:

http://www.redmine.org/boards/2/topics/25003

https://www.chiliproject.org/boards/1/topics/525

https://www.chiliproject.org/projects/chiliproject/wiki/HowTo_mirror_your_git_repository_on_Github

#6 - 28 Jun 2012 10:48 - Andriy Lesyuk

Am I right - Git supports only local repositories?..

#7 - 28 Jun 2012 16:27 - Lloyd Philbrook

Yes, git requires a local repository.  I assumed you were trying to circumvent the built in git support with your own methods to pull directly from github.

If not, then my suggestion would be to utilize one of the 3rd party ror implementations to allow for repo creation/deletion and then utilizing an update

hook (or use a preexisting plugin like github hook) to tell redmine to update the local repo.

#8 - 24 Dec 2013 09:07 - Andriy Lesyuk

The Github client or Octokit can be used to implement this...

#9 - 04 May 2014 08:32 - Andriy Lesyuk

See also: RedmineRepositories#Create-the-bare-repository and HowTo_keep_in_sync_your_git_repository_for_redmine.

#10 - 04 May 2014 21:08 - Andriy Lesyuk

- Status changed from Incomplete to Open

- % Done changed from 0 to 20

#11 - 04 May 2014 21:08 - Andriy Lesyuk

- Status changed from Open to In Progress
#12 - 05 May 2014 08:32 - Andriy Lesyuk

- % Done changed from 20 to 30

#13 - 06 May 2014 10:50 - Andriy Lesyuk

- % Done changed from 30 to 50

#14 - 06 May 2014 10:51 - Andriy Lesyuk

- Target version set to 0.5.0b

#15 - 09 May 2014 23:48 - Andriy Lesyuk

- % Done changed from 50 to 90

#16 - 10 May 2014 21:22 - Andriy Lesyuk

- Due date set to 10 May 2014

- Status changed from In Progress to Closed

- % Done changed from 90 to 100

Looking for beta-testers...
